module RECTGEN (EN, X, Y, X1, Y1, X2, Y2, CLK, R, G, B) ;

input CLK ;
input [9:0]X;
input [9:0]Y;
input [9:0]X1;
input [9:0]Y1;
input [9:0]X2;
input [9:0]Y2;
input EN;
output [1:0]R, G, B;

reg [5:0]color;

wire EN_OUT;

assign EN_OUT = ((X >= X1) && (X <= X2) && (Y >= Y1) && (Y <= Y2));
assign R = (EN && EN_OUT) ? color[5:4] : 0;
assign G = (EN && EN_OUT) ? color[3:2] : 0;
assign B = (EN && EN_OUT) ? color[1:0] : 0;

always @(posedge CLK) begin
  color <= color + 1;
end

endmodule 
